/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F15355
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.05 and above
        MPLAB 	          :  MPLAB X 5.20	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set O_RA0 aliases
#define O_RA0_TRIS                 TRISAbits.TRISA0
#define O_RA0_LAT                  LATAbits.LATA0
#define O_RA0_PORT                 PORTAbits.RA0
#define O_RA0_WPU                  WPUAbits.WPUA0
#define O_RA0_OD                   ODCONAbits.ODCA0
#define O_RA0_ANS                  ANSELAbits.ANSA0
#define O_RA0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define O_RA0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define O_RA0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define O_RA0_GetValue()           PORTAbits.RA0
#define O_RA0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define O_RA0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define O_RA0_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define O_RA0_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define O_RA0_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define O_RA0_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define O_RA0_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define O_RA0_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set O_RA1 aliases
#define O_RA1_TRIS                 TRISAbits.TRISA1
#define O_RA1_LAT                  LATAbits.LATA1
#define O_RA1_PORT                 PORTAbits.RA1
#define O_RA1_WPU                  WPUAbits.WPUA1
#define O_RA1_OD                   ODCONAbits.ODCA1
#define O_RA1_ANS                  ANSELAbits.ANSA1
#define O_RA1_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define O_RA1_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define O_RA1_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define O_RA1_GetValue()           PORTAbits.RA1
#define O_RA1_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define O_RA1_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define O_RA1_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define O_RA1_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define O_RA1_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define O_RA1_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define O_RA1_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define O_RA1_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set O_RA2 aliases
#define O_RA2_TRIS                 TRISAbits.TRISA2
#define O_RA2_LAT                  LATAbits.LATA2
#define O_RA2_PORT                 PORTAbits.RA2
#define O_RA2_WPU                  WPUAbits.WPUA2
#define O_RA2_OD                   ODCONAbits.ODCA2
#define O_RA2_ANS                  ANSELAbits.ANSA2
#define O_RA2_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define O_RA2_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define O_RA2_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define O_RA2_GetValue()           PORTAbits.RA2
#define O_RA2_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define O_RA2_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define O_RA2_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define O_RA2_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define O_RA2_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define O_RA2_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define O_RA2_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define O_RA2_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set O_RA3 aliases
#define O_RA3_TRIS                 TRISAbits.TRISA3
#define O_RA3_LAT                  LATAbits.LATA3
#define O_RA3_PORT                 PORTAbits.RA3
#define O_RA3_WPU                  WPUAbits.WPUA3
#define O_RA3_OD                   ODCONAbits.ODCA3
#define O_RA3_ANS                  ANSELAbits.ANSA3
#define O_RA3_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define O_RA3_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define O_RA3_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define O_RA3_GetValue()           PORTAbits.RA3
#define O_RA3_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define O_RA3_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define O_RA3_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define O_RA3_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define O_RA3_SetPushPull()        do { ODCONAbits.ODCA3 = 0; } while(0)
#define O_RA3_SetOpenDrain()       do { ODCONAbits.ODCA3 = 1; } while(0)
#define O_RA3_SetAnalogMode()      do { ANSELAbits.ANSA3 = 1; } while(0)
#define O_RA3_SetDigitalMode()     do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set stb aliases
#define stb_TRIS                 TRISAbits.TRISA4
#define stb_LAT                  LATAbits.LATA4
#define stb_PORT                 PORTAbits.RA4
#define stb_WPU                  WPUAbits.WPUA4
#define stb_OD                   ODCONAbits.ODCA4
#define stb_ANS                  ANSELAbits.ANSA4
#define stb_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define stb_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define stb_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define stb_GetValue()           PORTAbits.RA4
#define stb_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define stb_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define stb_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define stb_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define stb_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define stb_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define stb_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define stb_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set rs aliases
#define rs_TRIS                 TRISAbits.TRISA5
#define rs_LAT                  LATAbits.LATA5
#define rs_PORT                 PORTAbits.RA5
#define rs_WPU                  WPUAbits.WPUA5
#define rs_OD                   ODCONAbits.ODCA5
#define rs_ANS                  ANSELAbits.ANSA5
#define rs_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define rs_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define rs_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define rs_GetValue()           PORTAbits.RA5
#define rs_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define rs_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define rs_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define rs_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define rs_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define rs_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define rs_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define rs_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set O_RB0 aliases
#define O_RB0_TRIS                 TRISBbits.TRISB0
#define O_RB0_LAT                  LATBbits.LATB0
#define O_RB0_PORT                 PORTBbits.RB0
#define O_RB0_WPU                  WPUBbits.WPUB0
#define O_RB0_OD                   ODCONBbits.ODCB0
#define O_RB0_ANS                  ANSELBbits.ANSB0
#define O_RB0_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define O_RB0_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define O_RB0_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define O_RB0_GetValue()           PORTBbits.RB0
#define O_RB0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define O_RB0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define O_RB0_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define O_RB0_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define O_RB0_SetPushPull()        do { ODCONBbits.ODCB0 = 0; } while(0)
#define O_RB0_SetOpenDrain()       do { ODCONBbits.ODCB0 = 1; } while(0)
#define O_RB0_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define O_RB0_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set I_RB1 aliases
#define I_RB1_TRIS                 TRISBbits.TRISB1
#define I_RB1_LAT                  LATBbits.LATB1
#define I_RB1_PORT                 PORTBbits.RB1
#define I_RB1_WPU                  WPUBbits.WPUB1
#define I_RB1_OD                   ODCONBbits.ODCB1
#define I_RB1_ANS                  ANSELBbits.ANSB1
#define I_RB1_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define I_RB1_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define I_RB1_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define I_RB1_GetValue()           PORTBbits.RB1
#define I_RB1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define I_RB1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define I_RB1_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define I_RB1_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define I_RB1_SetPushPull()        do { ODCONBbits.ODCB1 = 0; } while(0)
#define I_RB1_SetOpenDrain()       do { ODCONBbits.ODCB1 = 1; } while(0)
#define I_RB1_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define I_RB1_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set I_RB2 aliases
#define I_RB2_TRIS                 TRISBbits.TRISB2
#define I_RB2_LAT                  LATBbits.LATB2
#define I_RB2_PORT                 PORTBbits.RB2
#define I_RB2_WPU                  WPUBbits.WPUB2
#define I_RB2_OD                   ODCONBbits.ODCB2
#define I_RB2_ANS                  ANSELBbits.ANSB2
#define I_RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define I_RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define I_RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define I_RB2_GetValue()           PORTBbits.RB2
#define I_RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define I_RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define I_RB2_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define I_RB2_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define I_RB2_SetPushPull()        do { ODCONBbits.ODCB2 = 0; } while(0)
#define I_RB2_SetOpenDrain()       do { ODCONBbits.ODCB2 = 1; } while(0)
#define I_RB2_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define I_RB2_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set O_RB3 aliases
#define O_RB3_TRIS                 TRISBbits.TRISB3
#define O_RB3_LAT                  LATBbits.LATB3
#define O_RB3_PORT                 PORTBbits.RB3
#define O_RB3_WPU                  WPUBbits.WPUB3
#define O_RB3_OD                   ODCONBbits.ODCB3
#define O_RB3_ANS                  ANSELBbits.ANSB3
#define O_RB3_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define O_RB3_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define O_RB3_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define O_RB3_GetValue()           PORTBbits.RB3
#define O_RB3_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define O_RB3_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define O_RB3_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define O_RB3_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define O_RB3_SetPushPull()        do { ODCONBbits.ODCB3 = 0; } while(0)
#define O_RB3_SetOpenDrain()       do { ODCONBbits.ODCB3 = 1; } while(0)
#define O_RB3_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define O_RB3_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set O_RB4 aliases
#define O_RB4_TRIS                 TRISBbits.TRISB4
#define O_RB4_LAT                  LATBbits.LATB4
#define O_RB4_PORT                 PORTBbits.RB4
#define O_RB4_WPU                  WPUBbits.WPUB4
#define O_RB4_OD                   ODCONBbits.ODCB4
#define O_RB4_ANS                  ANSELBbits.ANSB4
#define O_RB4_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define O_RB4_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define O_RB4_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define O_RB4_GetValue()           PORTBbits.RB4
#define O_RB4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define O_RB4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define O_RB4_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define O_RB4_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define O_RB4_SetPushPull()        do { ODCONBbits.ODCB4 = 0; } while(0)
#define O_RB4_SetOpenDrain()       do { ODCONBbits.ODCB4 = 1; } while(0)
#define O_RB4_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define O_RB4_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set O_RB5 aliases
#define O_RB5_TRIS                 TRISBbits.TRISB5
#define O_RB5_LAT                  LATBbits.LATB5
#define O_RB5_PORT                 PORTBbits.RB5
#define O_RB5_WPU                  WPUBbits.WPUB5
#define O_RB5_OD                   ODCONBbits.ODCB5
#define O_RB5_ANS                  ANSELBbits.ANSB5
#define O_RB5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define O_RB5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define O_RB5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define O_RB5_GetValue()           PORTBbits.RB5
#define O_RB5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define O_RB5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define O_RB5_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define O_RB5_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define O_RB5_SetPushPull()        do { ODCONBbits.ODCB5 = 0; } while(0)
#define O_RB5_SetOpenDrain()       do { ODCONBbits.ODCB5 = 1; } while(0)
#define O_RB5_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define O_RB5_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RB6 procedures
#define RB6_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define RB6_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define RB6_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define RB6_GetValue()              PORTBbits.RB6
#define RB6_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define RB6_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define RB6_SetPullup()             do { WPUBbits.WPUB6 = 1; } while(0)
#define RB6_ResetPullup()           do { WPUBbits.WPUB6 = 0; } while(0)
#define RB6_SetAnalogMode()         do { ANSELBbits.ANSB6 = 1; } while(0)
#define RB6_SetDigitalMode()        do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set RB7 procedures
#define RB7_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define RB7_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define RB7_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define RB7_GetValue()              PORTBbits.RB7
#define RB7_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define RB7_SetPullup()             do { WPUBbits.WPUB7 = 1; } while(0)
#define RB7_ResetPullup()           do { WPUBbits.WPUB7 = 0; } while(0)
#define RB7_SetAnalogMode()         do { ANSELBbits.ANSB7 = 1; } while(0)
#define RB7_SetDigitalMode()        do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set O_RC0 aliases
#define O_RC0_TRIS                 TRISCbits.TRISC0
#define O_RC0_LAT                  LATCbits.LATC0
#define O_RC0_PORT                 PORTCbits.RC0
#define O_RC0_WPU                  WPUCbits.WPUC0
#define O_RC0_OD                   ODCONCbits.ODCC0
#define O_RC0_ANS                  ANSELCbits.ANSC0
#define O_RC0_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define O_RC0_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define O_RC0_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define O_RC0_GetValue()           PORTCbits.RC0
#define O_RC0_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define O_RC0_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define O_RC0_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define O_RC0_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define O_RC0_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define O_RC0_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define O_RC0_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define O_RC0_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set O_RC1 aliases
#define O_RC1_TRIS                 TRISCbits.TRISC1
#define O_RC1_LAT                  LATCbits.LATC1
#define O_RC1_PORT                 PORTCbits.RC1
#define O_RC1_WPU                  WPUCbits.WPUC1
#define O_RC1_OD                   ODCONCbits.ODCC1
#define O_RC1_ANS                  ANSELCbits.ANSC1
#define O_RC1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define O_RC1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define O_RC1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define O_RC1_GetValue()           PORTCbits.RC1
#define O_RC1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define O_RC1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define O_RC1_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define O_RC1_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define O_RC1_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define O_RC1_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define O_RC1_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define O_RC1_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set O_RC2 aliases
#define O_RC2_TRIS                 TRISCbits.TRISC2
#define O_RC2_LAT                  LATCbits.LATC2
#define O_RC2_PORT                 PORTCbits.RC2
#define O_RC2_WPU                  WPUCbits.WPUC2
#define O_RC2_OD                   ODCONCbits.ODCC2
#define O_RC2_ANS                  ANSELCbits.ANSC2
#define O_RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define O_RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define O_RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define O_RC2_GetValue()           PORTCbits.RC2
#define O_RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define O_RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define O_RC2_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define O_RC2_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define O_RC2_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define O_RC2_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define O_RC2_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define O_RC2_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set O_RC3 aliases
#define O_RC3_TRIS                 TRISCbits.TRISC3
#define O_RC3_LAT                  LATCbits.LATC3
#define O_RC3_PORT                 PORTCbits.RC3
#define O_RC3_WPU                  WPUCbits.WPUC3
#define O_RC3_OD                   ODCONCbits.ODCC3
#define O_RC3_ANS                  ANSELCbits.ANSC3
#define O_RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define O_RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define O_RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define O_RC3_GetValue()           PORTCbits.RC3
#define O_RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define O_RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define O_RC3_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define O_RC3_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define O_RC3_SetPushPull()        do { ODCONCbits.ODCC3 = 0; } while(0)
#define O_RC3_SetOpenDrain()       do { ODCONCbits.ODCC3 = 1; } while(0)
#define O_RC3_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define O_RC3_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set O_RC4 aliases
#define O_RC4_TRIS                 TRISCbits.TRISC4
#define O_RC4_LAT                  LATCbits.LATC4
#define O_RC4_PORT                 PORTCbits.RC4
#define O_RC4_WPU                  WPUCbits.WPUC4
#define O_RC4_OD                   ODCONCbits.ODCC4
#define O_RC4_ANS                  ANSELCbits.ANSC4
#define O_RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define O_RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define O_RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define O_RC4_GetValue()           PORTCbits.RC4
#define O_RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define O_RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define O_RC4_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define O_RC4_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define O_RC4_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define O_RC4_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define O_RC4_SetAnalogMode()      do { ANSELCbits.ANSC4 = 1; } while(0)
#define O_RC4_SetDigitalMode()     do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set O_RC5 aliases
#define O_RC5_TRIS                 TRISCbits.TRISC5
#define O_RC5_LAT                  LATCbits.LATC5
#define O_RC5_PORT                 PORTCbits.RC5
#define O_RC5_WPU                  WPUCbits.WPUC5
#define O_RC5_OD                   ODCONCbits.ODCC5
#define O_RC5_ANS                  ANSELCbits.ANSC5
#define O_RC5_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define O_RC5_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define O_RC5_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define O_RC5_GetValue()           PORTCbits.RC5
#define O_RC5_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define O_RC5_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define O_RC5_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define O_RC5_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define O_RC5_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define O_RC5_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define O_RC5_SetAnalogMode()      do { ANSELCbits.ANSC5 = 1; } while(0)
#define O_RC5_SetDigitalMode()     do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/